unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Windows;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { private declarations }
    HookCounter: Integer;
    MsgCounter: Integer;
    procedure MyProc(var Msg: TMessage); message WM_POWERBROADCAST;
    procedure IncHookCounter;
    procedure IncMsgCounter;
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

var
  HookHandle: HHOOK = 0;

function HookProc(code: integer; wPar: WPARAM; lPar: LPARAM): LRESULT; stdcall;
begin
  if code < 0 then begin
     result := CallNextHookEx(HookHandle,code,wPar,lPar);
     Exit;
  end;
  if PCWPRetStruct(lPar)^.message = WM_POWERBROADCAST then
    case PCWPRetStruct(lPar)^.wParam of
      $04: Form1.IncHookCounter; // PBT_APMSUSPEND
      $12: Form1.IncHookCounter;  // PBT_APMRESUMEAUTOMATIC
    end;
  CallNextHookEx(HookHandle,code,wPar,lPar);
  result := 0;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ShowMessage('HookCounter: '+IntToStr(HookCounter)+#13+
              'MsgCounter: '+IntToStr(MsgCounter));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  HookHandle := SetWindowsHookEx(WH_CALLWNDPROCRET,@HookProc,0,GetCurrentThreadID());
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  UnhookWindowsHookEx(HookHandle);
end;

procedure TForm1.MyProc(var Msg: TMessage);
begin
  IncMsgCounter;
end;

procedure TForm1.IncHookCounter;
begin
  Inc(HookCounter);
end;

procedure TForm1.IncMsgCounter;
begin
  Inc(MsgCounter);
end;

initialization
  {$I unit1.lrs}

end.

